(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tsparticles-engine", "./Utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PathDrawer = void 0;
    const tsparticles_engine_1 = require("tsparticles-engine");
    const Utils_1 = require("./Utils");
    class PathDrawer {
        draw(context, particle, radius) {
            if (!particle.pathData) {
                return;
            }
            (0, Utils_1.drawPath)(context, radius, particle.pathData);
        }
        particleInit(container, particle) {
            const shape = particle.shapeData;
            if (!shape) {
                return;
            }
            particle.pathData = (0, tsparticles_engine_1.deepExtend)({}, shape);
        }
    }
    exports.PathDrawer = PathDrawer;
});
